// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ds_dbw_msgs:msg/PropulsionInfo.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "ds_dbw_msgs/msg/propulsion_info.hpp"


#ifndef DS_DBW_MSGS__MSG__DETAIL__PROPULSION_INFO__TRAITS_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__PROPULSION_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "ds_dbw_msgs/msg/detail/propulsion_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace ds_dbw_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PropulsionInfo & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: propulsion_torque_request
  {
    out << "propulsion_torque_request: ";
    rosidl_generator_traits::value_to_yaml(msg.propulsion_torque_request, out);
    out << ", ";
  }

  // member: propulsion_torque_actual
  {
    out << "propulsion_torque_actual: ";
    rosidl_generator_traits::value_to_yaml(msg.propulsion_torque_actual, out);
    out << ", ";
  }

  // member: engine_torque_request
  {
    out << "engine_torque_request: ";
    rosidl_generator_traits::value_to_yaml(msg.engine_torque_request, out);
    out << ", ";
  }

  // member: engine_torque_actual
  {
    out << "engine_torque_actual: ";
    rosidl_generator_traits::value_to_yaml(msg.engine_torque_actual, out);
    out << ", ";
  }

  // member: transmission_ratio
  {
    out << "transmission_ratio: ";
    rosidl_generator_traits::value_to_yaml(msg.transmission_ratio, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PropulsionInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: propulsion_torque_request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "propulsion_torque_request: ";
    rosidl_generator_traits::value_to_yaml(msg.propulsion_torque_request, out);
    out << "\n";
  }

  // member: propulsion_torque_actual
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "propulsion_torque_actual: ";
    rosidl_generator_traits::value_to_yaml(msg.propulsion_torque_actual, out);
    out << "\n";
  }

  // member: engine_torque_request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "engine_torque_request: ";
    rosidl_generator_traits::value_to_yaml(msg.engine_torque_request, out);
    out << "\n";
  }

  // member: engine_torque_actual
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "engine_torque_actual: ";
    rosidl_generator_traits::value_to_yaml(msg.engine_torque_actual, out);
    out << "\n";
  }

  // member: transmission_ratio
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "transmission_ratio: ";
    rosidl_generator_traits::value_to_yaml(msg.transmission_ratio, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PropulsionInfo & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace ds_dbw_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_dbw_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_dbw_msgs::msg::PropulsionInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_dbw_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_dbw_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const ds_dbw_msgs::msg::PropulsionInfo & msg)
{
  return ds_dbw_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<ds_dbw_msgs::msg::PropulsionInfo>()
{
  return "ds_dbw_msgs::msg::PropulsionInfo";
}

template<>
inline const char * name<ds_dbw_msgs::msg::PropulsionInfo>()
{
  return "ds_dbw_msgs/msg/PropulsionInfo";
}

template<>
struct has_fixed_size<ds_dbw_msgs::msg::PropulsionInfo>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<ds_dbw_msgs::msg::PropulsionInfo>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<ds_dbw_msgs::msg::PropulsionInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DS_DBW_MSGS__MSG__DETAIL__PROPULSION_INFO__TRAITS_HPP_
